<div style="position: relative" class="container">
    <div class="row">
        <div class="col-md-4"><span>Load average 1 min</span>
            <div class="progress progress-flat">
                <div id="probe-load-average-1m" role="progressbar" aria-valuenow="0" aria-min="0"
                     aria-max="5" style="width: 0"
                     class="progress-bar progress-bar-success"><span>0</span>
                </div>
            </div>
        </div>
        <div class="col-md-4"><span>Load average 5 min</span>
            <div class="progress progress-flat">
                <div id="probe-load-average-5m" role="progressbar" aria-valuenow="0" aria-min="0"
                     aria-max="5" style="width: 0"
                     class="progress-bar progress-bar-success"><span>0</span>
                </div>
            </div>
        </div>
        <div class="col-md-4"><span>Load average 15 min</span>
            <div class="progress progress-flat">
                <div id="probe-load-average-15m" role="progressbar" aria-valuenow="0" aria-min="0"
                     aria-max="5" style="width: 0"
                     class="progress-bar progress-bar-success"><span>0</span>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-lg-6"><span>RAM</span>
            <div class="progress progress-flat">
                <div id="probe-ram" role="progressbar" aria-valuenow="0" aria-min="0"
                     aria-max="100" style="width: 0"
                     class="progress-bar progress-bar-primary"><span>0 Octet / 0 Octet</span>
                </div>
            </div>
        </div>
        <div class="col-lg-6"><span>SWAP</span>
            <div class="progress progress-flat">
                <div id="probe-swap" role="progressbar" aria-valuenow="0" aria-min="0"
                     aria-max="100" style="width: 0"
                     class="progress-bar progress-bar-danger"><span>0 Octet / 0 Octet</span>
                </div>
            </div>
        </div>
    </div>
</div>

<!--suppress JSDuplicateCaseLabel -->
<script>
    var probeIsRunning = false;
    var probeInterval = null;
    function setStyleProbe(element, value, style)
    {
        element
            .removeClass('progress-bar-success')
            .removeClass('progress-bar-primary')
            .removeClass('progress-bar-warning')
            .removeClass('progress-bar-danger')
        ;
        if (value < style.low) { // vert
            element.addClass('progress-bar-success');
        } else if (value < style.medium) { // bleu
            element.addClass('progress-bar-primary');
        } else if (value < style.high) { // jaune
            element.addClass('progress-bar-warning');
        } else { // rouge
            element.addClass('progress-bar-danger');
        }
    }
    function readableBytes(size)
    {
        switch (true) {
            case size < 1024:
                return size + ' octets';
            case (size = size / 1024) < 1024:
                return (Math.round(size * 100) / 100) + ' Ko';
            case (size = size / 1024) < 1024:
                return (Math.round(size * 100) / 100) + ' Mo';
            case (size = size / 1024) < 1024:
                return (Math.round(size * 100) / 100) + ' Go';
            default:
                return size + ' To';
        }
    }
    function probeMercureCallback(data)
    {
        probeIsRunning = true;
        if (probeInterval) {
            clearInterval(probeInterval);
        }
        probeInterval = setInterval(function() {
            probeIsRunning = false;
            fetch('{{ url('admin_probe')|escape('js') }}', {headers: {"No-Session-Renewal": 'true'}});
        }, 5000);

        setProbeData(data);
    }
    function setProbeData(data)
    {
        let styles = {
            loadavg: {
                low: 0.7,
                medium: 1.2,
                high: 1.6
            },
            mem: {
                low: 25,
                medium: 50,
                high: 75
            }
        };

        let percentLoadavg1 = Math.min(Math.ceil(data.loadavg[0] / 5 * 100), 100);
        let percentLoadavg5 = Math.min(Math.ceil(data.loadavg[1] / 5 * 100), 100);
        let percentLoadavg15 = Math.min(Math.ceil(data.loadavg[2] / 5 * 100), 100);
        setStyleProbe(
            $('#probe-load-average-1m')
                .attr('aria-valuenow', data.loadavg[0])
                .css('width', percentLoadavg1 + '%')
                .find('span').text(Math.round(data.loadavg[0] * 100) / 100),
            data.loadavg[0],
            styles.loadavg
        );
        setStyleProbe(
            $('#probe-load-average-5m')
                .attr('aria-valuenow', data.loadavg[1])
                .css('width', percentLoadavg5 + '%')
                .find('span').text(Math.round(data.loadavg[1] * 100) / 100),
            data.loadavg[1],
            styles.loadavg
        );
        setStyleProbe(
            $('#probe-load-average-15m')
                .attr('aria-valuenow', data.loadavg[2])
                .css('width', percentLoadavg15 + '%')
                .find('span').text(Math.round(data.loadavg[2] * 100) / 100),
            data.loadavg[1],
            styles.loadavg
        );
        let currentMem = data.memory.total - data.memory.available;
        let txMem = data.memory.total ? currentMem / data.memory.total : 1;
        let percentMem = Math.min(Math.ceil(txMem * 100), 100);
        setStyleProbe(
            $('#probe-ram')
                .attr('aria-valuenow', Math.min(percentMem, 100))
                .css('width', percentMem + '%')
                .find('span')
                .text(readableBytes(currentMem * 1024) + ' / ' + readableBytes(data.memory.total * 1024)),
            percentMem,
            styles.mem
        );
        let currentSwap = data.swap.total - data.swap.available;
        let txSwap = data.swap.total ? currentSwap / data.swap.total : 0;
        let percentSwap = Math.min(Math.ceil(txSwap * 100), 100);
        setStyleProbe(
            $('#probe-swap')
                .attr('aria-valuenow', Math.min(percentSwap, 100))
                .css('width', percentSwap + '%')
                .find('span')
                .text(readableBytes(currentSwap * 1024) + ' / ' + readableBytes(data.swap.total * 1024)),
            percentSwap,
            styles.mem
        );
    }
    {{ mercure_callback([topic_probe], 'probeMercureCallback') }}
    var probeRunningAjax = false;
    var checkProbeRunningInterval = setInterval(function() {
        if (!probeIsRunning && !probeRunningAjax) {
            probeRunningAjax = true;
            fetch('{{ url('admin_probe')|escape('js') }}', {headers: {"No-Session-Renewal": 'true'}})
                .then(function (response) {
                    probeRunningAjax = false;
                    if (!response.ok) {
                        clearInterval(checkProbeRunningInterval);
                    }
                })
                .catch(function (response) {
                    probeRunningAjax = false;
                    clearInterval(checkProbeRunningInterval);
                });
        }
    }, 1100);
    setProbeData({{ meminfo|raw }});
</script>
